![Brew](http://shellscape.org/brew/nuget.png)
====

Brew is an open source library of interface components for ASP.NET which utilizes jQuery and jQuery UI.

If Brew looks familiar, that's for good reason. Brew is a heavily refactored fork of the Juice UI project.

## What makes Brew different

Creating a project that's just a copy of another would be silly. Brew stands out in a few ways from it's cousin.

* Brew uses an unobtrusive, but speedy means to render widgets. That means no more huge blocks of javascript in the rendered page, and Brew doesn't litter your tags with extra attributes.
* Brew's unobtrusive javascript runs quickly and is far less complex.
* Brew's extenders and controls are simpler and more intuitive to use. 
* Brew's codebase is much smaller, making it easier to maintain and fix bugs faster.
* Brew is a spartan release, no extra fluff or unnecessary extras.
* Brew contains all of the as-yet unreleased bug fixes from the JuiceUI master repository.

* Community interaction - This is a big one. If an issue, problem, pull request, etc. gets posted here, it's going to get looked into. 

## Documentation

The demo site for Brew is located at http://shellscape.org/brew. 
A Getting Started guide and documentation for Brew can be found on the [Wiki here on Github](https://github.com/shellscape/brew/wiki). 

## Getting Help

For bugs and unexpected problems using Brew, please file a new issue here on Github.

For quick questions, please feel free to tweet [@shellscape](https://twitter.com/shellscape) and/or use the [#brewdotnet](https://twitter.com/search/realtime?q=%23brewdotnet&src=typd) or [#getbrew](https://twitter.com/search/realtime?q=%23getbrew&src=typd) hashtag. If you don't use the hashtag, I may not see your tweet!

### Reporting Issues

Please submit any bugs to the Issues section of this repository. 
When submitting please be as detailed as possible and include the following information:

* Trouble publishing, building - full Operating System specifications for your development environment.
* Trouble deploying - full Operating Systems specifications for your deployment environment.
* Which IDE you’re using (eg. Visual Studio 2010, Web Developer Express, etc.)
* What type of website project you’re developing in (eg. Website, Web Application)
* A test case which reproduces the issue. (eg. a Gist. or zip for multiple files)
* Full Exception output including Stack Trace and any Inner Exception data.
 
## Boring Stuff

**Why create Brew?**

I had the pleasure to work on the original Juice UI project (check out the commit history) and while it was a great project, it was always limited in some aspects. 
Brew will enjoy a fast and frequent release cycle. Brew is also a different direction for it's cousin project, and everything that I had wanted to do with Juice. It's a significant departure and is unbound by the restrictions of it's cousin. 

**System Requirements**

Brew requires the .NET Framework v4.5. You can download it here: http://www.microsoft.com/en-us/download/details.aspx?id=30653
There are no plans to include support for earlier versions of .NET, that includes Sharepoint limitations.

**Licensing**

Unless otherwise stated, the code here is licensed under the MIT license. Have at it!
